RSpec.describe SearchyJson::Service do
  let!(:data_path) { File.join(File.dirname(__FILE__), '../../spec/fixtures/data.json') }
  let!(:primary_key) { 'Name' }
  let!(:search_fields) { ['Name', 'Type', 'Designed by'] }

  subject { SearchyJson::Service.new(data_path: data_path, primary_key: primary_key, search_fields: search_fields) }

  describe '#find' do
    context 'Support reverse keywords' do
      it 'finds two languages' do
        result = subject.find('Lisp Common')

        expect(result).to match_array(['Common Lisp', 'Lisp'])
      end
    end

    context 'Support exacts matching' do
      it 'finds one language' do
        result = subject.find('"Thomas Eugene"')

        expect(result).to eq(['BASIC'])
      end
    end

    context 'Support negative searching' do
      it 'finds result' do
        result = subject.find('"Thomas Eugene"')

        expect(result).to eq(['BASIC'])
      end
    end

    # context 'Support different fields' do
    #   it 'finds result' do
    #     result = subject.find('"Thomas Eugene"')

    #     expect(result).to eq(['BASIC'])
    #   end
    # end
  end
end
